﻿<html>
<head>
    <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
    <meta name="viewport" content="width=device-width, user-scalable=no">
    <script src="./dorukeker.github.io_files/jquery.min.js"></script>
    <script src="./dorukeker.github.io_files/bootstrap.min.js" integrity="sha384-Tc5IQib027qvyjSMfHjOMaLkfuWVxZxUPnCJA7l2mCWNIpG9mGCD8wGNIcPD7Txa" crossorigin="anonymous"></script>
    <link href="./dorukeker.github.io_files/bootstrap.min.css" rel="stylesheet" integrity="sha384-BVYiiSIFeK1dGmJRAkycuHAHRg32OmUcww7on3RYdg4Va+PmSTsz/K68vbdEjh4u" crossorigin="anonymous">
    <script src="./dorukeker.github.io_files/gyronorm.complete.min.js  "></script>
    <style type="text/css">
        .container {
            margin-top: 20px;
        }

        .tab-pane {
            margin-top: 15px;
        }

        .page-header {
            margin-top: 20px;
        }

        .input-group {
            margin-bottom: 20px;
        }

        input[type=text],
        textarea {
            box-shadow: none;
            -webkit-appearance: none;
            -webkit-box-shadow: none !important;
            -moz-box-shadow: none !important;
            box-shadow: none !important;
        }

        #dm .input-group {
            float: left;
            padding-left: 10px;
        }

            #dm .input-group.first {
                padding-left: 0px;
            }

        #dm .col-xs-12 {
            padding-left: 0;
        }
    </style>
    <script type="text/javascript">// Promises
        var _eid_promises = {};
        // Turn the incoming message from extension
        // into pending Promise resolving
        function() {
            window.addEventListener("message", function (event) {
                if (event.source !== window) return;
                if (event.data.src && (event.data.src === "background.js")) {
                    console.log("Page received: ");
                    console.log(event.data);
                    // Get the promise
                    if (event.data.nonce) {
                        var p = _eid_promises[event.data.nonce];
                        // resolve
                        if (event.data.result === "ok") {
                            if (event.data.signature !== undefined) {
                                p.resolve({ hex: event.data.signature });
                            } else if (event.data.version !== undefined) {
                                p.resolve(event.data.extension + "/" + event.data.version);
                            } else if (event.data.cert !== undefined) {
                                p.resolve({ hex: event.data.cert });
                            } else {
                                console.log("No idea how to handle message");
                                console.log(event.data);
                            }
                        } else {
                            // reject
                            p.reject(new Error(event.data.result));
                        }
                        delete _eid_promises[event.data.nonce];
                    } else {
                        console.log("No nonce in event msg");
                    }
                }
            }, false);
        }

        function TokenSigning1() {
            function nonce() {
                var val = "";
                var hex = "abcdefghijklmnopqrstuvwxyz0123456789";
                for (var i = 0; i < 16; i++) val += hex.charAt(Math.floor(Math.random() * hex.length));
                return val;
            }

            function messagePromise(msg) {
                return new Promise(function (resolve, reject) {
                    // amend with necessary metadata
                    msg["nonce"] = nonce();
                    msg["src"] = "page.js";
                    // send message
                    window.postMessage(msg, "*");
                    // and store promise callbacks
                    _eid_promises[msg.nonce] = {
                        resolve: resolve,
                        reject: reject
                    };
                });
            }
            this.getCertificate = function (options) {
                var msg = { type: "CERT", lang: options.lang, filter: options.filter };
                console.log("getCertificate()");
                return messagePromise(msg);
            };
            this.sign = function (cert, hash, options) {
                var msg = { type: "SIGN", cert: cert.hex, hash: hash.hex, hashtype: hash.type, lang: options.lang, info: options.info };
                console.log("sign()");
                return messagePromise(msg);
            };
            this.getVersion = function () {
                console.log("getVersion()");
                return messagePromise({
                    type: "VERSION"
                });
            };
        }</script>
</head>
<body onload="init_gn()">
    <div class="container">
        <div role="tabpanel">
            <!-- Nav tabs -->
            <ul class="nav nav-pills" role="tablist">
                <li role="presentation" class="active"><a href="https://dorukeker.github.io/gyronorm_samples/demo/#do" aria-controls="do" role="tab" data-toggle="tab" aria-expanded="true">Orientation</a></li>
                <li role="presentation" class=""><a href="https://dorukeker.github.io/gyronorm_samples/demo/#dm" aria-controls="dm" role="tab" data-toggle="tab" aria-expanded="false">Motion</a></li>
                <li role="presentation" class=""><a href="https://dorukeker.github.io/gyronorm_samples/demo/#logs" aria-controls="logs" role="tab" data-toggle="tab" aria-expanded="false">Logs</a></li>
            </ul>
            <!-- Tab panes -->
            <div class="tab-content">
                <div role="tabpanel" class="tab-pane active" id="do">
                    <div class="input-group col-xs-12">
                        <span class="input-group-addon">alpha</span>
                        <input type="text" class="form-control" id="do_alpha" disabled="">
                    </div>
                    <div class="input-group col-xs-12">
                        <span class="input-group-addon">beta</span>
                        <input type="text" class="form-control" id="do_beta" disabled="">
                    </div>
                    <div class="input-group col-xs-12">
                        <span class="input-group-addon">gamma</span>
                        <input type="text" class="form-control" id="do_gamma" disabled="">
                    </div>
                    <input type="button" onclick="set_head_gn()" value="Set Head Direction" class="col-xs-12 btn-warning btn">
                </div>
                <div role="tabpanel" class="tab-pane" id="dm">
                    <div class="col-xs-12">
                        Acceleration
                    </div>
                    <div class="input-group col-xs-4 first">
                        <span class="input-group-addon">x</span>
                        <input type="text" class="form-control" id="dm_x" disabled="">
                    </div>
                    <div class="input-group col-xs-4">
                        <span class="input-group-addon">y</span>
                        <input type="text" class="form-control" id="dm_y" disabled="">
                    </div>
                    <div class="input-group col-xs-4">
                        <span class="input-group-addon">z</span>
                        <input type="text" class="form-control" id="dm_z" disabled="">
                    </div>
                    <div class="col-xs-12">
                        Acceleration including gravity
                    </div>
                    <div class="input-group col-xs-4 first">
                        <span class="input-group-addon">x</span>
                        <input type="text" class="form-control" id="dm_gx" disabled="">
                    </div>
                    <div class="input-group col-xs-4">
                        <span class="input-group-addon">y</span>
                        <input type="text" class="form-control" id="dm_gy" disabled="">
                    </div>
                    <div class="input-group col-xs-4">
                        <span class="input-group-addon">z</span>
                        <input type="text" class="form-control" id="dm_gz" disabled="">
                    </div>
                    <input type="button" onclick="norm_gn()" value="Normalize" class="col-xs-6 btn-warning btn">
                    <input type="button" onclick="org_gn()" value="Original" class="col-xs-6 btn-warning btn">
                    <p>&nbsp;</p>
                    <div class="col-xs-12">
                        Rotation rate
                    </div>
                    <div class="input-group col-xs-12">
                        <span class="input-group-addon">alpha</span>
                        <input type="text" class="form-control" id="dm_alpha" disabled="">
                    </div>
                    <div class="input-group col-xs-12">
                        <span class="input-group-addon">beta</span>
                        <input type="text" class="form-control" id="dm_beta" disabled="">
                    </div>
                    <div class="input-group col-xs-12">
                        <span class="input-group-addon">gamma</span>
                        <input type="text" class="form-control" id="dm_gamma" disabled="">
                    </div>
                </div>
                <div role="tabpanel" class="tab-pane" id="logs">
                    <textarea class="col-xs-12 form-control" id="error-message" style="height:100px" placeholder="Log area..." disabled="">Device orientation is not available.
Device acceleration is not available.
Device acceleration incl. gravity is not available.
Device rotation rate is not available.
</textarea>
                </div>
            </div>
        </div>
    </div>
    <div style="display:none;">
        <input type="button" onclick="start_gn()" value="START" class="col-xs-6 btn-info btn">
        <input type="button" onclick="stop_gn()" value="STOP" class="col-xs-6 btn-info btn">
    </div>
    <script type="text/javascript">
        var gn;

        function init_gn() {
            var args = {
                logger: logger
            };

            gn = new GyroNorm();

            gn.init(args).then(function () {
                var isAvailable = gn.isAvailable();
                if (!isAvailable.deviceOrientationAvailable) {
                    logger({ message: 'Device orientation is not available.' });
                }

                if (!isAvailable.accelerationAvailable) {
                    logger({ message: 'Device acceleration is not available.' });
                }

                if (!isAvailable.accelerationIncludingGravityAvailable) {
                    logger({ message: 'Device acceleration incl. gravity is not available.' });
                }

                if (!isAvailable.rotationRateAvailable) {
                    logger({ message: 'Device rotation rate is not available.' });
                }

                start_gn();
            }).catch(function (e) {

                console.log(e);

            });
        }

        function logger(data) {
            $('#error-message').append(data.message + "\n");
        }

        function stop_gn() {
            gn.stop();
        }

        function start_gn() {
            gn.start(gnCallBack);
        }

        function gnCallBack(data) {
            $('#do_alpha').val(data.do.alpha);
            $('#do_beta').val(data.do.beta);
            $('#do_gamma').val(data.do.gamma);

            $('#dm_x').val(data.dm.x);
            $('#dm_y').val(data.dm.y);
            $('#dm_z').val(data.dm.z);

            $('#dm_gx').val(data.dm.gx);
            $('#dm_gy').val(data.dm.gy);
            $('#dm_gz').val(data.dm.gz);

            $('#dm_alpha').val(data.dm.alpha);
            $('#dm_beta').val(data.dm.beta);
            $('#dm_gamma').val(data.dm.gamma);
        }

        function norm_gn() {
            gn.normalizeGravity(true);
        }

        function org_gn() {
            gn.normalizeGravity(false);
        }

        function set_head_gn() {
            gn.setHeadDirection();
        }

        function showDO() {
            $('#do').show();
            $('#dm').hide();
            $('#btn-dm').removeClass('selected');
            $('#btn-do').addClass('selected');
        }

        function showDM() {
            $('#dm').show();
            $('#do').hide();
            $('#btn-do').removeClass('selected');
            $('#btn-dm').addClass('selected');
        }
    </script>

</body>
</html>